/**
 * 
 */
package org.processmining.models.performancemeasurement;

/**
 * @author arya
 * @email arya.adriansyah@gmail.com
 * @version Apr 14, 2009
 */
public class GlobalSettingsData {
	public final static int MILLISECOND = 1;
	public final static int SECOND = 2;
	public final static int MINUTE = 3;
	public final static int HOUR = 4;
	public final static int DAY = 5;

	private int selectedTimeUnit;
	private double fastestBoundPercentage = 0.25;
	private double slowestBoundPercentage = 0.25;

	public GlobalSettingsData() {
		selectedTimeUnit = MINUTE;
	}

	/**
	 * @return the selectedTimeUnit
	 */
	public int getSelectedTimeUnit() {
		return selectedTimeUnit;
	}

	/**
	 * @param selectedTimeUnit
	 *            the selectedTimeUnit to set
	 */
	public void setSelectedTimeUnit(int selectedTimeUnit) {
		this.selectedTimeUnit = selectedTimeUnit;
	}

	/**
	 * @return the fastestBoundPercentage
	 */
	public double getFastestBoundPercentage() {
		return fastestBoundPercentage;
	}

	/**
	 * @param fastestBoundPercentage
	 *            the fastestBoundPercentage to set
	 */
	public void setFastestBoundPercentage(double fastestBoundPercentage) {
		this.fastestBoundPercentage = fastestBoundPercentage;
	}

	/**
	 * @return the slowestBoundPercentage
	 */
	public double getSlowestBoundPercentage() {
		return slowestBoundPercentage;
	}

	/**
	 * @param slowestBoundPercentage
	 *            the slowestBoundPercentage to set
	 */
	public void setSlowestBoundPercentage(double slowestBoundPercentage) {
		this.slowestBoundPercentage = slowestBoundPercentage;
	}

	public int getDividerValue() {
		if (selectedTimeUnit == SECOND) {
			return 1000;
		} else if (selectedTimeUnit == MINUTE) {
			return 60000;
		} else if (selectedTimeUnit == HOUR) {
			return 3600000;
		} else if (selectedTimeUnit == DAY) {
			return 86400000;
		} else { // selected Time Unit == MILLISECOND
			return 1;
		}
	}

	public String getTimeUnitLabel() {
		switch (selectedTimeUnit) {
			case MILLISECOND :
				return "millisecond";
			case SECOND :
				return "second";
			case MINUTE :
				return "minute";
			case HOUR :
				return "hour";
			case DAY :
				return "day";
		}
		return null;
	}

	public Object[] getAvailableTimeUnitLabel() {
		return new Object[] { "millisecond", "second", "minute", "hour", "day" };
	}

}
