/**
 * 
 */
package org.processmining.models.performancemeasurement.dataelements;

import java.util.List;
import java.util.Map;

import org.processmining.models.fuzzyperformancediagram.FPDEdge;
import org.processmining.models.fuzzyperformancediagram.FPDNode;

/**
 * @author arya
 * @email arya.adriansyah@gmail.com
 * @version Mar 19, 2009
 */
public class FPDElementPerformanceMeasurementData {

	// for calculation about node
	public static final int WAITINGTIME = 0;
	public static final int SYNCHRONIZATIONTIME = 1;
	public static final int THROUGHPUTTIME = 2;

	protected Map<FPDNode, List<List<Double>>> nodePerformance; // store waiting time, synchronization time, and throughput time for each node 
	protected Map<FPDEdge<? extends FPDNode, ? extends FPDNode>, List<Double>> edgePerformance; // store moving time for each edge

	/**
	 * @return the nodePerformance
	 */
	public Map<FPDNode, List<List<Double>>> getNodePerformance() {
		return nodePerformance;
	}

	/**
	 * @param nodePerformance
	 *            the nodePerformance to set
	 */
	public void setNodePerformance(Map<FPDNode, List<List<Double>>> nodePerformance) {
		this.nodePerformance = nodePerformance;
	}

	/**
	 * @return the edgePerformance
	 */
	public Map<FPDEdge<? extends FPDNode, ? extends FPDNode>, List<Double>> getEdgePerformance() {
		return edgePerformance;
	}

	/**
	 * @param edgePerformance
	 *            the edgePerformance to set
	 */
	public void setEdgePerformance(Map<FPDEdge<? extends FPDNode, ? extends FPDNode>, List<Double>> edgePerformance) {
		this.edgePerformance = edgePerformance;
	}

}
